import http.client
import xml.etree.ElementTree as ET

class Error(Exception):
    pass

class CannotRetrieveUrlError(Error):
    def __init__(self, url):
        self.msg = "Cannot retrieve URL: " + url

class FeedItem(object):
    """
    Reprezentuje jeden item ve feedu, tzn.
    <item>
    ...
    </item>
    """
    pass

class Feed(object):
    """
    Reprezentuje feed, tzn. kanal, ve kterem jsou jednotlive prispevky.
    <channel>
    </channel>
    """

    def __init__(self, feed_xml):
        # tato promenna udrzuje string s XML daty, ktera byla
        # stazena ze serveru. Pouzijte ji pro parsovani XML.
        self.feed_xml = feed_xml

        self.title, self.desc, self.lang = self.parse_feed_info()

    def print_info(self):
        print("=====================")
        print("Feed info:")
        print("Title: " + self.title)
        print("Desc: " + self.desc)
        print("Lang: " + self.lang)
        print("=====================")
        print()

    def parse_feed_info(self):
        # TODO 2:z XML dat vrati trojici obsahujici informace o feedu
        # title, description, language
        pass

    def get_items(self):
        # TODO 3:z XML dat vrati vsechny itemy, ktere feed obsahuje
        # * nejprve generujte tuple s title, desc, guid
        # * potom generujte instance tridy FeedItem
        pass

class Reader(object):
    """
    Reprezentuje RSS ctecku, ktera umi cist vice RSS feedu.
    Pro jednoduchost budeme pouze cist jeden RSS feed.
    """

    def __init__(self, url):
        self.read_items_filename = 'rss_read.txt'
        self.url = url
        self.feed = None

    def fetch_feed(self):
        conn = http.client.HTTPConnection(self.url)
        conn.request("GET", "/")
        r = conn.getresponse()
        #print(type(r.status), type(r.reason))
        if r.status != 200:
            raise CannotRetrieveUrlError(self.url)

        xml = r.read()
        # print(xml)
        # TODO 1: doplnit vytvoreni objektu Feed do promenne self.feed

        conn.close()

    def get_already_read_items(self):
        # TODO 5:ziskat list jiz prectenych itemu ze souboru
        pass

    def read_feed(self):
        # TODO 4, X:z feedu precist neprectene itemy pomoci funkce Feed.get_items
        pass

def main():
    url = 'localhost:9000'
    reader = Reader(url)

    try:
        reader.fetch_feed()
        reader.read_feed()
    except CannotRetrieveUrlError as e:
        print(e)

if __name__ == '__main__':
    main()
